package ij2x.plugin;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
//import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Image;
import java.awt.Insets;
import java.awt.Color;
import java.awt.Dimension;

import java.util.MissingResourceException;
import java.util.Locale;
import java.util.ResourceBundle;

//import java.net.URL;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JPanel;
//import javax.swing.Icon;
import javax.swing.border.BevelBorder;
import javax.swing.BorderFactory;
import javax.swing.border.Border;

import ij.IJ;
import ij.ImageJ;
import ij.ImagePlus;
import ij.plugin.PlugIn;

//mport ij2x.plugin.imageborder.ImageBorderPanel;
import ij2x.util.ResourceString;
import ij2x.util.BorderlessButton;
import ij2x.util.AWTImages;
import ij2x.util.ImageIcons;


/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2012</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class AdjustPanel extends JPanel implements PlugIn, ActionListener, MouseListener, MouseMotionListener {

    protected ImagePlus imp;
    protected ImageJ ij;
    public JButton infoButton, draggedButton, closeButton, undecoratedButton;
    protected JButton brightnesContButton, winLevelButton, resizeCanButton, colorBalButton, thresholdButton;
    private JButton action;
    private BevelBorder bb ;//new BevelBorder for LOWER or RAISED type
    private Border lightGrayBorder = BorderFactory.createBevelBorder(bb.RAISED, Color.lightGray, Color.lightGray);
    private int actionCount = 0;
    private static int current;
    private long mouseDownTime;
    public static final int DOUBLE_CLICK_THRESHOLD = 150;
    public JPanel controlBarPanel=new JPanel();
    public JPanel panel=new JPanel();
    private GridBagLayout gblayout = new GridBagLayout();
    private static ResourceBundle resources;
    private int index = 0;

    static {
        try {
            resources = ResourceBundle.getBundle("ij2x.plugin.resources.AdjustBar",
                                                 Locale.getDefault());
        } catch (MissingResourceException mre) {
            System.err.println("resources/AdjustBar.properties not found");
            System.exit(1);
        }
    }

    public AdjustPanel() {
    }
    public void run(String arg){
        ij = IJ.getInstance();
        controlBarPanel=createControlBar();
    }

    public JPanel createControlBar(){

        java.awt.FlowLayout flayout = new java.awt.FlowLayout(java.awt.FlowLayout.LEFT);
        flayout.setHgap(0);
        flayout.setVgap(0);
        panel.setLayout(flayout);
        panel.setBorder(lightGrayBorder);

        ImageIcon b1o = ImageIcons.getIcons(this);

        AWTImages.setImageDir("adjustDir");


    String[] iconAllName = ResourceString.tokenize(ResourceString.getResourceString(resources, "adjustbar"));

    Image[][] icons = new Image[iconAllName.length][3];
    for(int i=0; i < iconAllName.length; i++){
        for(int j=0; j < 3; j++){
            icons[i][j]=((ImageIcon)AWTImages.createBufferedIcon(
                    this
                      , ResourceString.tokenize(ResourceString.getResourceString(resources, iconAllName[i]))[j]
                        , b1o.getImage()
                          , 24)).getImage();
        }
    }

        brightnesContButton=BorderlessButton.createButton(this, brightnesContButton, "Brightnes Contrast", icons[index++]);

        winLevelButton=BorderlessButton.createButton(this, winLevelButton, "Window Level", icons[index++]);

        colorBalButton=BorderlessButton.createButton(this, colorBalButton, "Color Balance", icons[index++]);

        resizeCanButton=BorderlessButton.createButton(this, resizeCanButton, "Resize Canvas", icons[index++]);

        thresholdButton=BorderlessButton.createButton(this, thresholdButton, "Threshold", icons[index++]);

        infoButton=BorderlessButton.createButton(this, infoButton, "Show Info ...", icons[index]);

        panel.add(brightnesContButton);
        panel.add(winLevelButton);
        panel.add(colorBalButton);
        panel.add(thresholdButton);
        panel.add(resizeCanButton);

        panel.add(infoButton);
        return panel;
     }

     void setButtonDim(JButton action, Dimension maxDim, Dimension preDim, Dimension minDim){
       action.setMaximumSize(maxDim);
       action.setPreferredSize(preDim);
       action.setMinimumSize(minDim);
   }

     void setBorderlessButton(JButton button){
           button.setMargin(new Insets(0, 0, 0, 0));
           button.setBorderPainted(false);
           button.setContentAreaFilled(false);
           button.setFocusPainted(false);
       }

       public void mousePressed(MouseEvent e) {
           action = (JButton)e.getSource();
           int x = e.getX();
           boolean doubleClick = (System.currentTimeMillis()-mouseDownTime)<=DOUBLE_CLICK_THRESHOLD;
           mouseDownTime = System.currentTimeMillis();
                if (!doubleClick) {
                }
        }

        public void mouseReleased(MouseEvent e) {}
        public void mouseExited(MouseEvent e) {}
        public void mouseClicked(MouseEvent e) {}
        public void mouseEntered(MouseEvent e) {}

        public void mouseDragged(MouseEvent e) {}
        public void mouseMoved(MouseEvent e) {
            JButton action = (JButton)e.getSource();
            int x = e.getX();
            boolean doubleClick = (System.currentTimeMillis()-mouseDownTime)<=DOUBLE_CLICK_THRESHOLD;
            mouseDownTime = System.currentTimeMillis();
                 if (!false) {
                     if(action == infoButton){
                         IJ.showStatus("Command: Show Info...");
                     }
                     else if(action == brightnesContButton){
                         IJ.showStatus("Command: Brightnes/Contrast");
                     }
                     else if(action == winLevelButton){
                         IJ.showStatus("Command: Window/Level");
                     }
                     else if (action == draggedButton) {
                         IJ.showStatus("Move...");
                     }
                     else if (action == closeButton) {
                         IJ.showStatus("Decorated Frame");
                     }
                     else if (action == undecoratedButton) {
                         IJ.showStatus("Undecorated Frame");
                     }
                     else if(action == resizeCanButton){
                         IJ.showStatus("Command: Canvas Size...");
                     }
                     else if(action == thresholdButton){
                         IJ.showStatus("Command: Thresold...");
                     }

                 }
        }
        public void actionPerformed(ActionEvent e){
            try {
                if(action == infoButton){
                    IJ.doCommand("Show Info...");
                }
                else if(action == brightnesContButton){
                    IJ.runPlugIn("ij.plugin.frame.ContrastAdjuster", "");
                }
                else if(action == winLevelButton){
                    IJ.runPlugIn("ij.plugin.frame.ContrastAdjuster", "wl");
                }
                else if(action == colorBalButton){
                    IJ.runPlugIn("ij.plugin.frame.ContrastAdjuster", "balance");
                }
                else if(action == resizeCanButton){
                    IJ.runPlugIn("ij.plugin.CanvasResizer", "");
                }
                else if(action == thresholdButton){
                    IJ.runPlugIn("ij.plugin.frame.ThresholdAdjuster", "");
                }
            } catch (Exception ex) {

            }
        }
}
